/*
  remember to cleanup the threaded cleaning.
  it is not faster to thread the cleaning.
  
  added howOften,nQueue
  
 */

#include <cstdio>
#include <vector>
#include <cstring>
#include <sys/stat.h>
#include <pthread.h>
#include "mUpPile.h"
#include "shared.h"
#include "general.h" //<-new way, to add additional analysis to angsd
#include "analysisFunction.h" //<-included fancy parsing of argument

#define THRESHOLD_FOR_NICEOUTPUT 200 //we normally print whenever we change a chr, but don't bother if we have more the 200, looks ugly for contig data

//small hack for the keepsites, this should be included allready in the bam parsing
#include "analysisKeepList.h"

//class to keep track of chunk order when dumping results
#include "printRes.h"

int andersSux =0;
general **allMethods = NULL;

extern pthread_mutex_t mUpPile_mutex;

int maxThreads=1;//this value is given from the commandline -nThreads
pthread_t thread1;
pthread_cond_t cvMaxThread;
pthread_mutex_t counterMut;

/*
  From v 4486 we assume that the data for a chunk belongs to the same chromosome.
  In the main entry function selector we pool the number of currently running threads every 2 seconds.
 */
int currentChr=-1;

int curRunning =0;
int chunkNumber =1;
int n_phenotypes;
printRes printer;


// print nicely into files.
int isAtty =1;


aHead *header = NULL;

//Max number of "finished" threads waiting to be printed
// -1 indicates no limit
int nQueueSize = -1;
// queueStop =1 shouldnt stop new threads
// queueStop =0 should spawn newthreads;
int queueStop =0;

// howoften should we printout to screen default 100
int howOften = 100;


void init(argStruct *arguments){
  if(!isatty(fileno(stderr))){
    isAtty = 0;
  }
  maxThreads=angsd::getArg("-nThreads",maxThreads,arguments);
  nQueueSize = angsd::getArg("-nQueueSize",nQueueSize,arguments);
  howOften = angsd::getArg("-howOften",howOften,arguments);
  if(!isatty(fileno(arguments->argumentFile)))
    fprintf(arguments->argumentFile,"--------------------\n[%s:%s()]\n\t-nThreads\t%d\tNumber of threads to use\n\t-nQueueSize\t%d\tMaximum number of queud elements\n\t-howOften\t%d\tHow often should the program show progress\n",__FILE__,__FUNCTION__,maxThreads,nQueueSize,howOften);
  //  fprintf(stderr,"nQueue=%d howOften=%d\n",nQueueSize,howOften);

  //these are  analysis that might be performed
  allMethods = extra(andersSux,arguments->outfiles,arguments->inputtype,arguments);
  pthread_mutex_init(&counterMut, NULL);
  pthread_cond_init (&cvMaxThread, NULL);
  
  
  //  fprintf(stderr,"[%s] \n",__FILE__);
  fprintf(stderr,"\t->Starting analysis\n");
  header = arguments->hd;
}


void destroy(){
  fprintf(stderr,"\t-> Calling destroy\n");
  while(1){
    pthread_mutex_lock(&counterMut);
    if(curRunning==0)
      break;
    fprintf(stderr," Waiting for nThreads:%d\n",curRunning);
    pthread_mutex_unlock(&counterMut);
    sleep(1);
  }
  pthread_mutex_unlock(&counterMut);

  for(int i=0;i<andersSux;i++)
    delete allMethods[i];

  delete [] allMethods;

}


int *populatePositions(const chunkyT *chk){
  int *ret = new int[chk->nSites];
  for(int i=0;i<chk->nSites;i++)
    ret[i] = chk->nd[i][0].refPos;

  return ret;
}




void cleanUptNodeArray(tNode *row,int nSamples){
  //  fprintf(stderr,"[%s]\n",__FUNCTION__);
    for(int i=0;i< nSamples;i++) {
      if(row[i].l2!=0)
	//	fprintf(stderr,"l3\t%d\n",chk->nd[s][i].l2);
	for(int j=0;j<row[i].l2;j++){
	//	fprintf(stderr,"removing indels\n");
	dalloc_node(row[i].insert[j]);
      }
      free(row[i].insert);
      dalloc_node(row[i]);
    }
    delete [] row;
}


chunkyT *splitFucker3000T(nodePoolT *dn,int nFiles);//from mUppile.cpp;

int main_analysis(funkyPars *p) {
  //  fprintf(stderr,"p=%p\tp->callback=%p\n",p,p->for_callback);
  //first step is to make a chunk of data from the sample "uppiles"
  if(p->for_callback!=NULL) {
    fcb *f = p->for_callback;
    //fprintf(stderr,"picking up fcb in main_analysis\n");
    chunkyT *chk = splitFucker3000T(f->dn,f->nFiles);
    for(int i=0;0&&i<chk->nSites;i++)
      fprintf(stderr,"pos[%d]\t%d\n",i,chk->nd[i][0].refPos+1);


    chk->regStart = f->regStart;
    chk->regStop = f->regStop;
    chk->refId = f->refId;
    //    fprintf(stderr,"regstart=%d regstop=%d\n",chk->regStart,chk->regStop);
    if(chk->refPos[0]>f->regStop){
      fprintf(stderr,"Problems with regions\n (chkFirst=%d lastReg=%d)\n",chk->refPos[0],f->regStop);
      fflush(stderr);
      exit(0);
    }

    //regstop and regstart are the usersupplied startstop region, strip ends if needed
    if(1&&(chk->nd[0][0].refPos<chk->regStart||chk->nd[chk->nSites-1][0].refPos>chk->regStop)){
      //      fprintf(stderr,"[%s]",__FILE__);
      //fprintf(stderr,"\t->Stripping outof region parts of chunkID=%d nchunkNsites=%d\n",p->chunkNumber,chk->nSites);
      //      fprintf(stderr,"\t->chk=(%d,%d)\tregs=(%d,%d)\n",chk->nd[0][0].refPos,chk->nd[chk->nSites-1][0].refPos,chk->regStart,chk->regStop);
      //      fflush(stderr);

      int at=0;
      for(int i=0;i<chk->nSites;i++){//can be written faster
	if(chk->nd[i][0].refPos<chk->regStart)//should cleanup
	  cleanUptNodeArray(chk->nd[i],chk->nSamples);
	//	  continue;
	else if(chk->nd[i][0].refPos<chk->regStop)
	  chk->nd[at++] = chk->nd[i];
	else{//should cleanup
	  //	  fprintf(stderr,"\ncleaning up i=%d\n",i);
	  cleanUptNodeArray(chk->nd[i],chk->nSamples);
	  //break;
	}
      }

      chk->nSites = at;
      //      fprintf(stderr,"nsties=%d\n",chk->nSites);
      
    }
    //    fprintf(stderr,"nsties=%d\n",chk->nSites);
    //now chk contains the merged data
    p->chk = chk;
    p->posi = populatePositions(chk);//<-will be new approach
    p->refId = chk->refId;//thiss will be new approach
    p->numSites=chk->nSites;
  
    p->nInd = chk->nSamples;  
  }

  //run all methods (ORDER is defined in general.cpp)
  for(int i=0;i<andersSux;i++)
    allMethods[i]->run(p);

  return 1;
}



void interface(funkyPars *p){
  if(p->killSig==1){
    //    fprintf(stderr,"chunkNumber=%d is the killSig\n",p->chunkNumber);
    //    return ;
  }

  if(p->killSig==0)
    main_analysis(p);//dont do analysis on the killsig chunk
  
  //  fprintf(stderr,"Num elem in queue: %lu number of current running threads:%d\n",printer.contains(),curRunning);
  printer.prop(p);
}

void *slave(void *ptr){
  funkyPars *p = (funkyPars *) ptr;
  interface(p);

  pthread_mutex_lock( &counterMut );
  curRunning--;


  if(nQueueSize==-1){//no limit on queuesize, always signal
    pthread_cond_signal(&cvMaxThread);
  }else{
    // this is for limiting the number of elements in queue. 
    // Only a problem with large >1000 samples.    
    if(printer.contains()<(unsigned int)nQueueSize){
      pthread_cond_signal(&cvMaxThread);
      queueStop =0; //can
    }else
      queueStop =1; //should not
  }
  //  fprintf(stderr,"queueStop =%d contains=%lu\n",queueStop,printer.contains());
  pthread_mutex_unlock( &counterMut );
  pthread_exit(NULL);
}


void *slave2(void *ptr){
  funkyPars *p = (funkyPars *) ptr;
  if(p->killSig==0)
    main_analysis(p);
  printFunky(p);
  pthread_mutex_unlock( &counterMut );
  pthread_exit(NULL);
}

void master2(funkyPars *p){
  //  fprintf(stderr,"[%s] Number of threads running=%d\n",__FUNCTION__,curRunning);
  pthread_mutex_lock( &counterMut );
  if(pthread_create( &thread1, NULL, slave2, (void*) p)){
    fprintf(stderr,"Problem spawning thread\n");
    exit(0);
  }
  pthread_detach(thread1);
}



void master(funkyPars *p){
  //  fprintf(stderr,"[%s] Number of threads running=%d inqueue=%lu\n",__FUNCTION__,curRunning,printer.contains());
  pthread_mutex_lock( &counterMut );
  extern int SIG_COND;
  if(0&&p->chunkNumber>10)//debug check never true in public
    SIG_COND =0;
  curRunning++;
  if(curRunning==maxThreads||queueStop==1){
    //fprintf(stderr,"We are running max number of threads will wait for finishing threads: %d\n",curRunning);
    pthread_cond_wait(&cvMaxThread, &counterMut);
    //fprintf(stderr,"Done waiting for finishing threads:%d\n",curRunning);
  }
  pthread_mutex_unlock( &counterMut );
  if(pthread_create( &thread1, NULL, slave, (void*) p)){
    fprintf(stderr,"Problem spawning thread\n");
    exit(0);
  }
  pthread_detach(thread1);
}

/*
  This is the function that determines whether or not to start a new thread
*/
void selector(funkyPars *p){
  //  fprintf(stderr,"refId = %d currentChr=%d currentRunning=%d\n",p->refId,currentChr,curRunning);
  //printHd(allMethods[0]->header,stderr);
  //exit(0);

  //  fprintf(stderr,"selector \n");
  if(p==NULL){
    p = allocFunkyPars();
    p->killSig = 1;
  }else
    p->extras = new void*[andersSux];//funky
  
  if(p->killSig!=1){
    if(currentChr==-1)
      currentChr = p->refId;
    else if(currentChr!=p->refId){
      //change of chr detected wait untill all threads are done
      if(allMethods[0]->header->n_ref<THRESHOLD_FOR_NICEOUTPUT)
	fprintf(stderr," Change of chromo detected Waiting for nThreads:%d\n",curRunning);
      while(1){
	pthread_mutex_lock(&counterMut);
	if(curRunning==0){
	  pthread_mutex_unlock(&counterMut);//need to do this because rest of while is not used
	  break;
	}
	if(allMethods[0]->header->n_ref<THRESHOLD_FOR_NICEOUTPUT){
	  fprintf(stderr," Change of chromo detected Waiting for nThreads:%d printer.containt=%lu\n",curRunning,printer.contains());
	  fflush(stderr);
	}
	pthread_mutex_unlock(&counterMut);
	sleep(1);
      }
      
      currentChr = p->refId;
      ((filter *)allMethods[0])->readSites();//<-used for filter if -doFilter==2 and -filter with .keep
      //chunkNumber =1;//<-lets not reset the chkId the printqueue might get confused. 
    }
  }
  p->chunkNumber = chunkNumber++;

  if(maxThreads==1)
    interface(p);
  else if(maxThreads==2)//simple serialization, allow one chunk to be computated
    master2(p);
  else
    master(p);
}


/*
  initialize all pointers to zero
 */

funkyPars *allocFunkyPars(){
  //  fprintf(stderr,"allocing funkypars\n");
  funkyPars *r = new funkyPars;

  //  r->sites = NULL;
  r->counts = NULL;
  r->likes = NULL;
  r->post = NULL;
  r->phat = NULL;

  r->major = NULL;
  r->minor = NULL;
  r->depth = NULL;

  r->results = NULL;
  r->ref = NULL;
  r->anc= NULL;
  r->keepSites =NULL;
  //allocate structures;

  r->results = new funkyPrint;
  r->results->freq = new funkyPrintFreq;
  r->results->asso = new funkyPrintAsso;
  //set nullpointers
  r->results->asso->stat=NULL;
  r->results->asso->keepInd=NULL;
  r->results->asso->freq=NULL;
  r->results->asso->lrt_snp=NULL;
  r->results->freq->pml=NULL;
  r->results->freq->pmlun= NULL;
  r->results->freq->pEM=NULL;
  r->results->freq->pEMun=NULL;

  r->chk = NULL;
  r->for_callback = NULL;
  r->killSig =0;

  r->posi = NULL;
  r->refId = -1;
  return r;
}





void deallocFunkyPars(funkyPars *p) {
  //clean up data related to each analysis class;
  for(int i=0;i<andersSux;i++)
    allMethods[i]->clean(p);
  
  
  //cleanup begin  

  delete[] p->keepSites;
  
  //  fprintf(stderr,"[%s] cleaning funkypars\n",__FUNCTION__);  
  delete p->results->freq;
  delete p->results->asso;
  delete p->results;

  if(p->depth!=NULL){
    for(int i=0;i<p->numSites;i++)
      delete [] p->depth[i];
    delete [] p->depth;
  }

  if(1){
    if(p->anc!=NULL)
      delete []  p->anc;
    if(p->ref!=NULL)
      delete [] p->ref;
  }

  //cleanup extra stuff
  void cleanUpChunkyT(chunkyT *chk);//<- from mUpPile.h
  if(p->chk!=NULL){
    //    fprintf(stderr,"cleanuing up chunkyT\n");
    cleanUpChunkyT(p->chk);
    p->chk = NULL;
  }

  if(p->for_callback!=NULL){
    fcb *f = p->for_callback;
    for(int i=0;i<f->nFiles;i++)
      if(f->dn[i].l!=0)//this is nescesarry...
	delete [] f->dn[i].nds;
    delete [] f->dn;
    delete f;
    f=NULL;
  }
  delete [] p->extras;

  delete [] p->posi;//<-new way
  
  delete p;

}

//plus one, plus 33
void printChunkyT(chunkyT *chk,double **liks,char *refs,FILE *fp){
  for(int s=0;s<chk->nSites;s++){
    fprintf(fp,"%d\t%d\t",chk->refId,chk->nd[s][0].refPos+1);
    if(refs!=NULL)
      fprintf(fp,"%c\t",intToRef[refs[s]]);
    for(int n=0;n<chk->nSamples;n++){
      tNode &nd = chk->nd[s][n];
      fprintf(fp,"%d\t",nd.l);
      for(int i=0;i<nd.l;i++)
	fprintf(fp,"%c",nd.seq[i]);
      fprintf(fp,"\t");
      for(int i=0;i<nd.l;i++)
	fprintf(fp,"%c",nd.qs[i]+33);
      fprintf(fp,"\t");
      for(int i=0;i<10;i++)
	fprintf(fp,"%f ",liks[s][n*10+i]);
    }
    fprintf(fp,"\n");
  }
}



void *cleanFunky(void *pars){
  funkyPars *p = (funkyPars *) pars;
  deallocFunkyPars(p);
  pthread_exit(NULL);
}


pthread_t cleanThread;
//only one instance at a time is running this function
void printFunky(funkyPars *p){
  //  fprintf(stderr,"printFunky killsig=%d\n",p->killSig);
  if(p->killSig==0) {//don't print the empty killSig chunk
    if((p->chunkNumber%howOften)==0){
      if(isAtty)
	fprintf(stderr,"\r\t->printing at chr: %s pos:%d chunknumber %d",header->name[p->refId],p->posi[0],p->chunkNumber);
      else
	fprintf(stderr,"\t->printing at chr: %s pos:%d chunknumber %d\n",header->name[p->refId],p->posi[0],p->chunkNumber);
    }
    for(int i=0;i<andersSux;i++)
      allMethods[i]->print(p);
    //    fprintf(stderr,"hello\n");
    //for nThreads>2 we will thread the deallocation
    if(maxThreads<=2)//DRAGON always do clean unthreaded ANDERS
      deallocFunkyPars(p);
    else{
      if(pthread_create( &cleanThread, NULL, cleanFunky, (void*) p)){
	fprintf(stderr,"Problem spawning thread\n");
	exit(0);
      }
      // fprintf(stderr,"ret=%d\n",ret);
      pthread_detach(cleanThread);
    }
 
  }else{
    delete p->results->asso;
    delete p->results->freq;
    delete p->results;
    delete p;
    pthread_mutex_unlock(&mUpPile_mutex);
    fprintf(stderr,"\n");//after last positions print add a neu line mutafuka

  }

}

//////////////////////////////////////////////////////////////////////////
//   Stuff to remove from this file
//////////////////////////////////////////////////////////////////////////


// a,c,g,t,n
// A,C,G,T,N
// 0,1,2,3,4
int refToInt[256] = {
  0,1,2,3,4,4,4,4,4,4,4,4,4,4,4,4,//15
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//31
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//47
  0,1,2,3,4,4,4,4,4,4,4,4,4,4,4,4,//63
  4,0,4,1,4,4,4,2,4,4,4,4,4,4,4,4,//79
  4,4,4,4,3,4,4,4,4,4,4,4,4,4,4,4,//95
  4,0,4,1,4,4,4,2,4,4,4,4,4,4,4,4,//111
  4,4,4,4,3,4,4,4,4,4,4,4,4,4,4,4,//127
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//143
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//159
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//175
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//191
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//207
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//223
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,//239
  4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4//255
};

char intToRef[5] = {'A','C','G','T','N'};



int fexists(const char* str){///@param str Filename given as a string.
  struct stat buffer ;
  return (stat(str, &buffer )==0 ); /// @return Function returns 1 if file exists.
}

size_t fsize(const char* fname){
  struct stat st ;
  stat(fname,&st);
  return st.st_size;
}

std::vector <char *> dumpedFiles;//small hack for getting a nice vector of outputfiles
FILE *openFile(const char* a,const char* b){
  if(0)
    fprintf(stderr,"[%s] %s %s",__FUNCTION__,a,b);
  char *c = new char[strlen(a)+strlen(b)+1];
  strcpy(c,a);
  strncat(c,b,strlen(b));
  //  fprintf(stderr,"\t-> Dumping file: %s\n",c);
  dumpedFiles.push_back(strdup(c));
  FILE *fp = fopen(c,"w");
  delete [] c;
  return fp;
}
gzFile openFileGz(const char* a,const char* b,const char *mode){
  if(0)
    fprintf(stderr,"[%s] %s%s\n",__FUNCTION__,a,b);
  char *c = new char[strlen(a)+strlen(b)+1];
  strcpy(c,a);
  strncat(c,b,strlen(b));
  //  fprintf(stderr,"\t-> Dumping file: %s\n",c);
  dumpedFiles.push_back(strdup(c));
  gzFile fp = getGz(c,mode);
  delete [] c;
  return fp;
}


FILE *getFILE(const char*fname,const char* mode){
  int writeFile = 0;
  for(size_t i=0;i<strlen(mode);i++)
    if(mode[i]=='w')
      writeFile = 1;
  FILE *fp;
  if(NULL==(fp=fopen(fname,mode))){
    fprintf(stderr,"\t->Error opening FILE handle for file:%s exiting\n",fname);
    exit(0);
  }
  return fp;
}

FILE *openFile(const char* a,const char* b,int i){
  char ary[5000];
  snprintf(ary,5000,"%s%d",b,i);
  return openFile(a,ary);  
}

void popBack(const char *a,const char*b,int to){
  char ary[5000];
  snprintf(ary,5000,"%s0-%d",b,to);
  dumpedFiles.push_back(strdup(ary));
}


gzFile getGz(const char*fname,const char* mode){
  int writeFile = 0;
  for(size_t i=0;i<strlen(mode);i++)
    if(mode[i]=='w')
      writeFile = 1;

  //  fprintf(stderr,"\t-> opening: %s\n",fname);
  gzFile fp=Z_NULL;
  if(NULL==(fp=gzopen(fname,mode))){
    fprintf(stderr,"\t-> Error opening gzFile handle for file:%s exiting\n",fname);
    exit(0);
  }
  return fp;
}
